import { ActionPlugin, Action } from '../manager/action'
import { PluginTypes, ActionTypes } from '../constant'
import { Data } from '../schema'
import { Util } from '../plugins'

export type Alias = Record<string, string>

export type RequestMeta = {
    url?: string,
    method?: 'post' | 'POST' | 'get' | 'GET',
    params?: Data,
    data?: Data,
    alias?: Alias,
}

export default {
    name: ActionTypes.Request,
    type: PluginTypes.Action,
    dependentMetas: ['url', 'method', 'params', 'data', 'alias'] as Array<keyof RequestMeta>,
    handler(requestMeta: Action<RequestMeta>, util: Util){
        return util.http(requestMeta)
    }
} as ActionPlugin