import { RendererProps } from '../renderer'
import { getCurrentInstance, ComponentInternalInstance } from 'vue'
import { pluginDriver } from '../../plugins'

export default function(props: RendererProps){
    const parser = pluginDriver.getParser(props)
    const instance = getCurrentInstance() as ComponentInternalInstance
    const callHook = (hook: string) => {

        const hookHandler = parser[hook]

        hookHandler && hookHandler.call(instance.proxy)
    }

    return {
        callHook,
    }
}