import { getCurrentInstance } from 'vue'
import { UITypes } from '../../constant'
import { isFalse } from '../../util'
import { pluginDriver } from '../../plugins'

export type OpenLoading = (isFullscreen?: Boolean) => void
export type CloseLoading = () => void

export function useLoading(){
    const Loading: any = pluginDriver.getUI(UITypes.Loading)
    let loadingInstance: any
    const openLoading: OpenLoading = (isFullscreen?: Boolean): void => {
        const instance = getCurrentInstance()
        const options = isFullscreen ? {
            fullscreen: true,
            lock: true,
        } : {
            target: instance?.vnode.el
        }

        loadingInstance = Loading.service(options)
    }

    const closeLoading: CloseLoading = () => loadingInstance && loadingInstance.close()

    return {
        openLoading,
        closeLoading,
    }
}