import { RendererProps, ParserUtil } from '../renderer'
import { pluginDriver } from '../../plugins'
import { SetupContext, ref, reactive, toRefs, watch, computed, toRef } from 'vue'
import { ComponentNode } from '../../schema'
import { isFalse, mergeObjects } from '../../util'

// 调用解析器parse，返回初始化的ComponentNode，并提供重新渲染组件的方法

export default function useParser(schema: RendererProps, context: SetupContext, parserUtil: ParserUtil){
    const {
        isInit,
        component,
        props,
        events,
        children,
        methods = {},
    }: ComponentNode = pluginDriver.parseSchema(schema, context, parserUtil)

    return {
        isInit,
        component,
        props,
        events,
        children,
        methods,
    }
}