/**
 * 通用解析器
 */
import { SetupContext } from 'vue'
import { ComponentNode, NormalizedSchemaNode } from '../schema'
import { ParserPlugin } from '../manager/parser'
import { Util } from '../plugins'
import { toPascalCase } from '../util'
import { ParserTypes, PluginTypes } from '../constant'

export default {
    name: ParserTypes.Common,  // 插件名称
    type: PluginTypes.Parser,
    parse: (schema: NormalizedSchemaNode, context: SetupContext, {
        pluginDriver
    }: Util) => {
        const component = pluginDriver.getUI(toPascalCase(schema.type))

        return {
            component,
            props: schema.meta,
            children: schema.items
        } as ComponentNode
    },
} as ParserPlugin