/**
 * 建站平台框架，对应解析器
 */
import { SetupContext } from 'vue'
import { ComponentNode, NormalizedSchemaNode, SchemaNode } from '../../schema'
import { Util } from '../../plugins'
import { ParserPlugin } from '../../manager/parser'
import useMenus from './useMenus'
import { ParserTypes, UITypes, PluginTypes } from '../../constant'
import { AppConfig } from '../../engine'

export default {
    name: ParserTypes.Frame,  // 插件名称
    type: PluginTypes.Parser,
    ui: UITypes.Frame,
    parse: (props: NormalizedSchemaNode, context: SetupContext, {
        appConfig
    }: Util ) => {
        const {
            isInit,
            title,
            currentRoute,
            routes
        } = useMenus(appConfig as AppConfig)

        return {
            isInit,
            props: {
                ...(props as SchemaNode).meta,
                title,
                routes,
                currentRoute,
            },
        } as ComponentNode
    }
} as ParserPlugin