import { computed } from 'vue'
import { PluginDriver } from '../../plugins'
import { ActionSchema, TreeSchema } from '../../schema'

// 处理表格右侧操作列
export default function useActions(schema: TreeSchema, pluginDriver: PluginDriver){
    const columns = computed( () => schema.items?.map( (item: any): any => {
        const {actions} = item
        const hasActions: boolean = !!(actions && actions?.length)

        return hasActions ? {
            ...item,
            actions: actions.map( (action: ActionSchema): ActionSchema => ({
                ...action,
                onClick: () => pluginDriver.handleAction(action.meta)
            }))
        } : item
    }) )

    return {
        columns,
    }
}