import { defineConfig } from 'vite'
import vue from '@vitejs/plugin-vue'
import path from 'path';

// https://vitejs.dev/config/
export default defineConfig({
  plugins: [vue()],
  build: {
    outDir: 'lib',
    lib: {
        entry: path.resolve(__dirname, 'src/index.ts'),
        name: 'Enginejs',
    },
    rollupOptions: {
        external: ['vue', 'vue-router', 'vue-seed-ui'],
        output: {
            // 在 UMD 构建模式下为这些外部化的依赖提供一个全局变量
            globals: {
                vue: 'Vue',
            },
        },
    },
},
})
